﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Transactions; // lisättävä referencesiin

namespace ohjaus9
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
            ohjaus9.ohjaus9Entities ohjaus9Entities;
            System.Windows.Data.CollectionViewSource reseptiViewSource;
            System.Data.Objects.ObjectQuery<ohjaus9.Resepti> reseptiQuery;
            System.Windows.Data.CollectionViewSource ruokalajiViewSource;
            System.Data.Objects.ObjectQuery<ohjaus9.Ruokalaji> ruokalajiQuery;

        public MainWindow()
        {
            InitializeComponent();
        }

        private System.Data.Objects.ObjectQuery<Resepti> GetReseptiQuery(ohjaus9Entities ohjaus9Entities)
        {
            // Auto generated code

            System.Data.Objects.ObjectQuery<ohjaus9.Resepti> reseptiQuery = ohjaus9Entities.Resepti;
            // To explicitly load data, you may need to add Include methods like below:
            // reseptiQuery = reseptiQuery.Include("Resepti.Ruokalaji").
            // For more information, please see http://go.microsoft.com/fwlink/?LinkId=157380
            // Update the query to include Ohje data in Resepti. You can modify this code as needed.
            reseptiQuery = reseptiQuery.Include("Ohje");
            // Returns an ObjectQuery.
            return reseptiQuery;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

            ohjaus9Entities = new ohjaus9.ohjaus9Entities();
            // Load data into Resepti. You can modify this code as needed.
            reseptiViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("reseptiViewSource")));
            reseptiQuery = this.GetReseptiQuery(ohjaus9Entities);
            reseptiViewSource.Source = reseptiQuery.Execute(System.Data.Objects.MergeOption.AppendOnly);
            // Load data into Ruokalaji. You can modify this code as needed.
            ruokalajiViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("ruokalajiViewSource")));
            ruokalajiQuery = this.GetRuokalajiQuery(ohjaus9Entities);
            ruokalajiViewSource.Source = ruokalajiQuery.Execute(System.Data.Objects.MergeOption.AppendOnly);
        }

        private System.Data.Objects.ObjectQuery<Ruokalaji> GetRuokalajiQuery(ohjaus9Entities ohjaus9Entities)
        {
            // Auto generated code

            System.Data.Objects.ObjectQuery<ohjaus9.Ruokalaji> ruokalajiQuery = ohjaus9Entities.Ruokalaji;
            // Returns an ObjectQuery.
            return ruokalajiQuery;
        }

        private void buttonPrev_Click(object sender, RoutedEventArgs e)
        {
            if (reseptiViewSource.View.CurrentPosition > 0 )
                reseptiViewSource.View.MoveCurrentToPrevious();
        }

        private void buttonNext_Click(object sender, RoutedEventArgs e)
        {
            if (reseptiViewSource.View.CurrentPosition < ((CollectionView)reseptiViewSource.View).Count - 1)
                reseptiViewSource.View.MoveCurrentToNext();
        }

        private void buttonAdd_Click(object sender, RoutedEventArgs e)
        {

            Resepti uusiresepti = new Resepti
            // seuraavat tiedot pitäisi tietysti kysyä erillisellä lomakkeella
            {
                Nimi = "Hernekeitto",
                Henkilomaara = 4,
                Kuvaus = "perusherkku",
                RuokalajiID = 1 // tämä pitää keksiä jostakin, pitäisi olla erillinen listbox tms josta valitaan
            };

            // voidaan lisätä liittyvät objektit suoraan oliomallin kautta
            Ohje uusiohje = new Ohje();
            uusiohje.Vaihenro = 1;
            uusiohje.Ohjeteksti = "sotke kaikki kattilaan";
            uusiresepti.Ohje.Add(uusiohje);
            Ohje uusiohje2 = new Ohje();
            uusiohje2.Vaihenro = 2;
            uusiohje2.Ohjeteksti = "Lämmitä";
            uusiresepti.Ohje.Add(uusiohje2);

            ohjaus9Entities.Resepti.AddObject(uusiresepti);
            ohjaus9Entities.SaveChanges();
            // päivittää gridin ajantasalle
            reseptiViewSource.Source = reseptiQuery.Execute(System.Data.Objects.MergeOption.AppendOnly);
            reseptiViewSource.View.MoveCurrentToLast();

        }

        private void buttonDelete_Click(object sender, RoutedEventArgs e)
        {
            // poistetaan malliksi resepti
            // pitää tehdä transaktiolla siltä varalta, että jotain menee pieleen kesken poistelun
            // poistetaan ensimmäiseksi reseptiin liittyvät viittaukset ohje- ja liittyy-tauluista ja vasta sen jälkeen resepti
            using (TransactionScope scope = new TransactionScope())
            {
 /*
                // ohjeen poistaminen
                System.Windows.Data.CollectionViewSource reseptiOhjeViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("reseptiOhjeViewSource")));
                Ohje r = (Ohje)reseptiOhjeViewSource.View.CurrentItem;
                ohjaus9Entities.DeleteObject(r);
                ohjaus9Entities.SaveChanges();
*/
                Resepti r = (Resepti)reseptiViewSource.View.CurrentItem;

                List<Ohje> ohjeet = r.Ohje.ToList<Ohje>();


                for (int i = (ohjeet.Count - 1); i >= 0; i--)
                {

                    ohjaus9Entities.DeleteObject(ohjeet[i]);

                }
                List<Liittyy> liittyy = r.Liittyy.ToList<Liittyy>();
                for (int i = (liittyy.Count - 1); i >= 0; i--)
                {

                    ohjaus9Entities.DeleteObject(liittyy[i]);

                }
                ohjaus9Entities.DeleteObject(r);
                ohjaus9Entities.SaveChanges();
                scope.Complete();
            }
        }
        private void buttonSave_Click(object sender, RoutedEventArgs e)
        {
            ohjaus9Entities.SaveChanges();
        }

        private void buttonUpdate_Click(object sender, RoutedEventArgs e)
        {
            Resepti r = (Resepti)reseptiViewSource.View.CurrentItem;
            r.Nimi = "Mykykeitto";
            ohjaus9Entities.SaveChanges();

        }
    }
}
